import { Action, combineReducers } from 'redux';
import { routerReducer, RouterState } from 'react-router-redux';
import { SagaIterator } from 'redux-saga';
import { Effect, fork, ForkEffect } from 'redux-saga/effects';

import * as Member from 'member';

export interface State {
  member: Member.State;
  router: RouterState;
}

export const reducer = combineReducers<State>({
  member: Member.reducer,
  router: routerReducer,
});

export function* sagas(): SagaIterator {
  yield fork(Member.sagas);
}


// export function* sagas(): Iterator<Effect> {
//   function* itor(values: {[key: string]: string | any}): Iterator<Effect> {
//     for (let name in values) {
//       if (values.hasOwnProperty(name)) {
//         let saga = values[name];
//         console.log('key:' + name + ' value:' + saga);
//         if (typeof saga === 'object') {
//           itor(saga);
//         } else {
//           yield fork(saga);
//         }
//       }
//     }
//   }

//   itor(_sagas);
// }
